Chimera2
========
Chimera2 is a very lightweight web browser for X11/Athena. This source is
derived from the final development snapshot of Chimera 2.0p19, as well as
well as the Debian patches that continued until 2013, both of which can be
gotten from [Debian jessie's package](https://packages.debian.org/source/jessie/chimera2)

Building
--------
Debian lists the following packages as required for building:

- libjpeg-dev
- libpng-dev
- xutils-dev
- zlib1g-dev
- libxaw7-dev
- libxmu-dev
- libxt-dev
- libsm-dev
- libice-dev
- libxpm-dev
- libxext-dev
- libx11-dev

The build system is rather archaic, and is tuned by modifying `Common.tmpl`
and `Imakefile`. Once you're fine with your modifications (or just want to
use the shipped defaults), run

    xmkmf -a &&
    make

This should give you a binary at `chimera/chimera`, which appears to be
fully self-contained.

Run-time configuration
----------------------
Chimera2 uses an x11-style resources file at ~/.chimera/resources, and will
not start up unless you define at least `html.defaultFont` in there. The
following is a full list of resources that Chimera2 appears to use and
examples of values or ??? in case the usage is unclear and it is not set
anywhere in the code.

    convert.convertFiles: ~/.chimera_convert:~john/lib/convert:/local/infosys/lib/convert

    html.defaultFont: -*-*-*-*-*-*-*-*-*-*-*-*-*-*
    html.propFontPattern: -*-lucida-*-*-*-*-*-*-*-*-*-*-iso10646-1
    html.fixedFontPattern: -*-fixed-*-*-*-*-*-*-*-*-*-*-iso8859-1
    html.leftMargin: 20
    html.rightMargin: 20
    html.bottomMargin: 20
    html.topMargin: 20
    html.printHTMLErrors: false
    html.textLineSpace: 3
    html.tableCellInfinity: 0
    html.inlineTimeOut: 5000
    html.selectTimeOut: 1000
    html.flowDebug: false
    html.constraintDebug: false
    html.printTags: false
    html.cssFile: ~/.chimera/default.css
    html.dlIndent: 20

    plain.font: -*-lucida-medium-r-normal-sans-17-120-100-100-p-96-iso10646-1

    chimera.helpURL: ???
    chimera.homeURL: http://example.org
    chimera.maxDownloads: 4
    chimera.printLoadMessages: false
    chimera.printTaskInfo: false
    chimera.urlLogFile: ~/debug/chimeraurls.log

    cache.directory: ~/.chimera/cache
    cache.persist: false
    cache.ignoreExpires: false
    cache.maxSize: 0
    cache.ttl: 0

    view.path: /usr/local/bin:/usr/bin:/bin
    view.capFiles: ~/.chimera/mailcap:~/.mailcap

    bookmark.filename: ~/.chimera/bookmarks.html
    bookmark.header: <html><body><h2>Bookmarks</h2><ul>
    bookmark.footer: </ul></body></html>

    file.autoLoad: index.html

    http.userAgent: Chimera/2.0alpha
    http.acceptLanguage: fi;q=1,en;q=0.9

    ftp.dirheader: <html><body><h2>FTP Directory</h2><ul>
    ftp.dirtrailer: </ul></body></html>

    mailto.dirheader: <html><body><h2>Mailto</h2><ul>
    mailto.dirtrailer: </body></html>
    user.email: foobar@example.org
    mailto.mailer: /usr/bin/sendmail -t

You'll most likely want to use a simpler configuration than this. A usable
default `.chimera/resources` is

    html.defaultFont: -*-*-*-*-*-*-*-*-*-*-*-*-*-*
    chimera.homeURL: http://example.org
    bookmark.filename: ~/.chimera/bookmarks.html

Known bugs
----------

- Saving pages will often segfault, even when loading them would work.
- http:// links that redirect to HTTPS hang with "0 bytes read so far."
- If current URL has query parameters containing a slash, relative links
  are mishandled.
- Some problem with displaying images on 68k.news and Frogfind: investigate
  further
- Use-after-free when navigating away from a webpage
